{ (c) by Igor Dikshew // Uni Tula }

UNIT InsStr;

INTERFACE

USES InsConst, Spisoc;

{
 ⮫쪮  뢠,   樨  ᮤন 䠩 ந
।⢥  ,  ⮬  ᥭ   ॠ쭮 䠩
᫥    ᮤন  䠩. ᫥   䠩 
頥  । ᫥騬  室 㤥 ᭮ 뢠
  䠩  ,   ᥣ,   ࠧ    ࠧ
 ᠬ  ࠡ.  ⮬, ࠭ ᮤন   ᥭ묨
ﬨ    䠩  㣨 .
}

     { ᮤন ⥪⮢ 䠩  }
PROCEDURE ReadFileInToMemory (FileName : String);
     {   ᮤন  ⥪⮢ 䠩}
PROCEDURE WriFileFromMemory (FileName : String);
     {⠢ ப S    Cou }
PROCEDURE InsertNewString (S : String; Cou : LongInt);
     { ப  Cou 樨}
PROCEDURE DeleteString (Cou : LongInt);
     {   ப  樨 Cou}
FUNCTION GetString (Cou : LongInt) : String;
     {뢠 ப S  ⮩,  ࠭  樨 Cou}
PROCEDURE PutString (S : String; Cou : LongInt);
     {頥 ⢮ ப  䠩}
FUNCTION ContString : LongInt;
     {頥  ࢮ ப, ᮤঠ ப S}
     { ந  樨 Cou  ࢮ ᮢ}
     {   㠫쭮 䠩. ᫨ ᮢ }
     {뫮,  頥 0}
FUNCTION SearchConcat (S : String; Cou : LongInt) : LongInt;

IMPLEMENTATION

PROCEDURE ReadFileInToMemory (FileName : String);
VAR
   T : Text;
   S : String;
BEGIN
     InsConst_Count := 0;
     NewRecord;
     Assign (T, FileName);
     ReSet (T);
     While not EOF (T) Do Begin
           ReadLn (T, S);
           Inc (InsConst_Count);
           IF InsConst_HEADER^.NEXT = InsConst_HEADER THEN BEGIN
              AddFirst;
              InsConst_Current := InsConst_HEADER^.NEXT
           END ELSE BEGIN
               Adding (InsConst_Current);
               InsConst_Current := InsConst_Current^. Next;
           END;
           InsConst_Current^. St := S;
     End;
     Close (T);
END;

PROCEDURE WriFileFromMemory (FileName : String);
VAR
   T : Text;
BEGIN
     Assign (T, FileName);
     ReWrite (T);
     WHILE InsConst_Count > 0 DO BEGIN
           InsConst_Current := InsConst_HEADER^.NEXT;
           WriteLn (T, InsConst_Current^. St);
           Dec (InsConst_Count);
           DelFirst (InsConst_Current);
     END;
     DoneRecord;
     Close (T);
END;

PROCEDURE InsertNewString (S : String; Cou : LongInt);
VAR
   Count : LongInt;
BEGIN
     IF Cou > InsConst_Count THEN Cou := InsConst_Count;
     InsConst_Current := InsConst_HEADER;
     Count := 1;
     WHILE Count < Cou DO BEGIN
           InsConst_Current := InsConst_Current^. Next;
           Inc (Count);
     END;
     IF InsConst_Current = InsConst_HEADER THEN BEGIN
        AddFirst;
        InsConst_Current := InsConst_HEADER^.NEXT
     END ELSE BEGIN
         Adding (InsConst_Current);
         InsConst_Current := InsConst_Current^. Next;
     END;
     InsConst_Current^. St := S;
     Inc (InsConst_Count);
END;

PROCEDURE DeleteString (Cou : LongInt);
VAR
   Count : LongInt;
BEGIN
     IF InsConst_Count = 0 THEN Exit;
     IF (Cou < 1) OR (Cou > InsConst_Count) THEN Exit;
     InsConst_Current := InsConst_HEADER;
     Count := 1;
     WHILE Count < Cou DO BEGIN
           InsConst_Current := InsConst_Current^. Next;
           Inc (Count);
     END;
     IF InsConst_Current <> InsConst_HEADER THEN
        Killer (InsConst_Current)
     ELSE
        DelFirst (InsConst_Current);
     Dec (InsConst_Count);
END;

FUNCTION GetString (Cou : LongInt) : String;
VAR
   Count : LongInt;
BEGIN
     IF (InsConst_Count = 0) OR (Cou > InsConst_Count) THEN BEGIN
        GetString := '';
        Exit;
     END;
     InsConst_Current := InsConst_HEADER;
     Count := 0;
     WHILE Count < Cou DO BEGIN
           InsConst_Current := InsConst_Current^. Next;
           Inc (Count);
     END;
     GetString := InsConst_Current^. St;
END;

PROCEDURE PutString (S : String; Cou : LongInt);
VAR
   Count : LongInt;
BEGIN
     IF (InsConst_Count = 0) OR (Cou > InsConst_Count) THEN Exit;
     InsConst_Current := InsConst_HEADER;
     Count := 0;
     WHILE Count < Cou DO BEGIN
           InsConst_Current := InsConst_Current^. Next;
           Inc (Count);
     END;
     InsConst_Current^. St := S;
END;

FUNCTION ContString : LongInt;
BEGIN ContString := InsConst_Count END;

FUNCTION SearchConcat (S : String; Cou : LongInt) : LongInt;
VAR
   Count : LongInt;
   Num : Byte;
BEGIN
     IF (InsConst_Count = 0) OR (Cou > InsConst_Count) THEN Exit;
     InsConst_Current := InsConst_HEADER;
     Count := 0;
     WHILE Count < Cou DO BEGIN
           InsConst_Current := InsConst_Current^. Next;
           Inc (Count);
     END;
     Num := 0;
     WHILE Count <= InsConst_Count DO BEGIN
           Num := Pos (S, InsConst_Current^. St);
           IF Num > 0 THEN Break;
           Inc (Count);
           InsConst_Current := InsConst_Current^. Next;
     END;
     SearchConcat := Count;
END;

END.
